<?php

namespace XenMake\StyleProperty\Repository;

class Node extends XFCP_Node
{
    public function getNodeListExtras(\XF\Tree $nodeTree)
    {
        list($nodeIds) = $this->getOnlineUsers();

        $nodeExtras = parent::getNodeListExtras($nodeTree);

        foreach ($nodeExtras AS $nodeId => $nodeExtra)
        {
            $nodeExtras[$nodeId]['xmsearchusers'] = 0;

            if (!empty($nodeIds[$nodeId]))
            {
                $nodeExtras[$nodeId]['xmsearchusers'] = $nodeIds[$nodeId];
            }
        }

        return $nodeExtras;
    }

    public function getOnlineUsers()
    {
        $sessionActivityRepo = $this->getSessionActivityRepo();

        $sessionActivityFinder = $sessionActivityRepo->getSessionActivityForForumViewing();
        $onlineUsers = $sessionActivityFinder->fetch();

        $nodeIds = [];

        foreach ($onlineUsers AS $name => $onlineUser)
        {
            if (!empty($onlineUser['params']['node_id']))
            {
                if (isset($nodeIds[$onlineUser['params']['node_id']]))
                {
                    $nodeIds[$onlineUser['params']['node_id']] +=1;
                }
                else
                {
                    $nodeIds[$onlineUser['params']['node_id']] = 1;
                }
            }

        }

        return array($nodeIds);
    }

    protected function getSessionActivityRepo()
    {
        return $this->repository('XF:SessionActivity');
    }
}