<?php

namespace XenMake\StyleProperty\Repository;

class UserActivity extends XFCP_UserActivity
{
    public function getSessionActivityForForumViewing()
    {
        $finder = $this->finder('XF:SessionActivity');

        $finder
            ->activeOnly()
            ->order('view_date', 'DESC');

        $finder
            ->restrictType('');

        $finder->with('User');

        return $finder;
    }

    public function findForumMemberViewers()
    {
        $forumMemberViewersFinder = $this->findForOnlineList('member');

        $forumMemberViewersFinder
            ->applyMemberVisibilityRestriction()
            ->where('controller_name', 'XF\Pub\Controller\Forum')
            ->where('controller_action','Forum');

        return $forumMemberViewersFinder;
    }

    public function countGuestOnline($type)
    {
        $finder = $this->finder('XF:SessionActivity');

        $finder
            ->activeOnly()
            ->restrictType('guest');

        switch ($type)
        {

            case 'forum':
                $finder
                ->where('controller_name', 'XF\Pub\Controller\Forum')
                ->where('controller_action','Forum');
                break;
        }
        return $finder;
    }
}